/*
 * OMRON ZN-THX21-S + ZN-THX21-S 
 * 2016-12-14 Kouichi Hirabayashi
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <stdarg.h>
#include <ctype.h>
#include <time.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/uio.h>

void Usage();
void error(char *, char *);
int dump(char *, int);
int Recv(int, char *, int);
int serOpen(char *, int);
int serClose(int);
int htoa(char *, char *, int);
int setGateway(char *);
int sMODE();
int sVER();
int sRTCW();
int nREQ();
int sRS();
int sR();
int sW();
int sRTCR();
int cSTARTREC();
int cSTOPREC();
int cOUTREC();
int cRESET();
int cCLRERR();
int cCLRALM();
int htoa(char *, char *, int);
int atoh(char *, int *);
char *strsave(char *);

//#define HOST	"192.168.3.41"	// ZN-THX21-S
//#define HOST	"192.168.3.42"	// ZN-THX21-S
#define HOST	"zn"	// ZN-THX21-S
//#define HOST	"zn2"	// ZN-THX21-S
#define PORT	2323

int fd;
int Bflg;	// begin rec. (start record)
int Eflg;	// end rec. (start record)
int Gflg;	// set gateway
int Mflg;	// set mode
int Oflg;	// out rec. (out record)
int Pflg;	// set parameters
int Rflg;	// reset (restart)
int Tflg;	// set time
int aflg;	// clear alarm
int dflg;	// debug info.
int pflg;	// get parameters
int sflg;	// get status
int eflg;	// clear error
int tflg;	// get time
int vflg;	// get version

char *host, *gw;
char *cmd;
char buf[BUFSIZ];

int main(argc, argv) char **argv;
{
  char *s;
  int i, n, par, val;

  cmd = argv[0];
  while (--argc > 0 && (*++argv)[0] == '-' && !isdigit((*argv)[1]))
	for (s = argv[0]+1; *s; s++)
		switch (*s) {
		case 'B':
			Bflg++;
			break;
		case 'E':
			Eflg++;
			break;
		case 'G':
			if (s[1] != '\0') {
				gw = strsave(s + 1);
				s += strlen(s) - 1;
			}
			else
				Usage();
			Gflg++;
			break;
		case 'M':
			val = -1;
			sscanf(s + 1, "%d", &val);
			val = atoi(s + 1);
printf("val(%d)\n", val);
			s += strlen(s) - 1;
			Mflg++;
			break;
		case 'O':
			Oflg++;
			break;
		case 'P':
			par = val = -1;
			if (s[1] != '\0') {
				if (strncmp(s + 1, "0x", 2) == 0)
					sscanf(s + 3, "%x,%d", &par, &val);
				else
					sscanf(s + 1, "%d,%d", &par, &val);
printf("par(%d) val(%d)\n", par, val);
				s += strlen(s) - 1;
			}
			else
				Usage();
			Pflg++;
			break;
		case 'R':
			Rflg++;
			break;
		case 'T':
			Tflg++;
			break;
		case 'a':
			aflg++;
			break;
		case 'e':
			eflg++;
			break;
		case 'p':
			pflg++;
			break;
		case 's':
			sflg++;
			break;
		case 't':
			tflg++;
			break;
		case 'v':
			vflg++;
			break;
		default:
			Usage();
		}
//printf("-- argc(%d), argv[0](%s)\n", argc, argv[0]); //exit(0);
  if (argc > 0)
	host = argv[0];
  else
	host = HOST;
  if ((fd = serOpen(host, PORT)) < 0)
	error("can not open %s", HOST);
  usleep(200000);
  if (Bflg)
	cSTARTREC();
  else if (Gflg)
	setGateway(gw);
  else if (Eflg)
	cSTOPREC();
  else if (Mflg)
	sMODE(val);
  else if (Oflg)
	cOUTREC();
  else if (Pflg)
	sW(0x21, 0x0103A8C0);	// 192.168.3.1
  else if (Rflg)
	cRESET();
  else if (Tflg)
	sRTCW();
  else if (tflg)
	sRTCR();
  else if (aflg)
	cCLRALM();
  else if (eflg)
	cCLRERR();
  else if (pflg)
	sR();
  else if (sflg)
	sRS();
  else if (vflg)
	sVER();
  else
	nREQ();
//cCLRALM();
  serClose(fd);
}

int sVER()
{
  char *cmd = "AA550AFF8004F0F0F0000000FF00\r\n";
  char *s, *p, str[64];
  int i, n, x;
  double t, h;

//printf("(%s)\n", cmd);
  if (write(fd, cmd, strlen(cmd)) < 0)
	perror("sVER():");
  if ((n = Recv(fd, buf, sizeof(buf))) < 0)
	fprintf(stderr, "sVER(): Recv() error\n");
  if (dflg)
	dump(buf, n);
  sscanf(buf + 4, "%2X", &x);
  sscanf(buf + 28, "%2X", &x);
  if (x == 0x60)
	p = "ZN-THX21-S (٥ơ";
  else if (x == 0x61)
	p = "ZN-DPX21-S (ơ";
  else if (x == 0x62)
	p = "ZN-KMX21 (̥ơ";
  else if (x == 0x63)
	p = "ZN-CTX21 (ʰϥ)";
  else if (x == 0x64)
	p = "D6FZ-FGX21 (ή̥ơ";
  else
	p = "Unknown device";
  printf(" ID: %s\n", p);
  sscanf(buf + 30, "%2X", &x);
  printf("᥸㡼С: %d\n", x);
  sscanf(buf + 32, "%2X", &x);
  printf("ޥʡС: %d\n", x);
  sscanf(buf + 34, "%2X", &x);
  printf("꡼ֹ: %d\n", x);
  htoa(buf + 36, str, 8);
  printf("ꥢʥС: %s\n", str);
  return 0;
}

int nREQ()
{
  char *cmd = "AA550AFF5100F0F0F0000000FF00\r\n";
  char *s;
  int i, n, x;
  double t, h;

//printf("(%s)\n", cmd);
  if (write(fd, cmd, strlen(cmd)) < 0)
	perror("nREQ():");
  if ((n = Recv(fd, buf, sizeof(buf))) < 0)
	fprintf(stderr, "nREQ(): Recv() error\n");
  if (dflg)
	dump(buf, n);
  sscanf(buf + 4, "%2X", &x);
//printf("0x%02X\n", x);
#if 0
  if (x != 0x81) {
	sscanf(buf + 6, "%2X", &x);
	if (x == 0x0A)
		fprintf(stderr, "¹ԤǤʤ⡼\n");
	else if (x == 0x10)
		fprintf(stderr, "󥵥顼\n");

	fprintf(stderr, "N-REQ ۾ｪλ\n");
	return -1;
  }
#endif
  sscanf(buf + 30, "%2X", &x);
  if (x == 0x60) {	// ZN-THX21-S
//printf("0x%X\n", x);
	sscanf(buf + 38, "%8X", &x);
	t = (double)x * 0.1;
//printf("%d\n", x);
	sscanf(buf + 46, "%8X", &x);
//printf("%d\n", x);
	h = (double)x * 0.1;
	printf("%.1f %.1f\n", t, h);
  }
  else
	fprintf(stderr, " ID 0x%02x: not supported.\n", x);
  return 0;
}

// 

int sRTCR()
{
  char *cmd = "AA550AFF1013F0F0F0000000FF00\r\n";
  char *s;
  int i, n, y, m, d, H, M, S, x;

printf("(%s)\n", cmd);
//  if (write(fd, cmd, 16) < 0)
  if (write(fd, cmd, strlen(cmd)) < 0)
	perror("sRTCR():");
  if ((n = Recv(fd, buf, sizeof(buf))) < 0)
	fprintf(stderr, "sRTCR(): Recv() error\n");
  if (dflg)
	dump(buf, n);
  sscanf(buf + 28, "%2X", &y);
  sscanf(buf + 30, "%2X", &m);
  sscanf(buf + 32, "%2X", &d);
  sscanf(buf + 34, "%2X", &H);
  sscanf(buf + 36, "%2X", &M);
  sscanf(buf + 38, "%2X", &S);
// printf("%02x %02x %02x %02x %02x %02x\n", y, m, d, H, M, S);
  printf("%02d-%02d-%02d %02d:%02d:%02d\n", y, m, d, H, M, S);
  return 0;
}

// 

int sRTCW()
{
  time_t clock;
  struct tm *tm;
  char *fmt = "AA5510FF1014F0F0F0000000FF%02X%02X%02X%02X%02X%02X00\r\n";
  char *s, *t, cmd[128];
  int i, n, y, m, d, H, M, S, x;

  time(&clock);
  tm = localtime(&clock);
  printf("%02d-%02d-%02d %02d:%02d:%02d\n",
	tm->tm_year + 1900, tm->tm_mon + 1, tm->tm_mday,
	tm->tm_hour, tm->tm_min, tm->tm_sec);
//printf("%02X%02X%02X%02X%02X%02X\n", tm->tm_year - 100, tm->tm_mon + 1, tm->tm_mday, tm->tm_hour, tm->tm_min, tm->tm_sec);
  sprintf(cmd, fmt, tm->tm_year - 100, tm->tm_mon + 1, tm->tm_mday,
	tm->tm_hour, tm->tm_min, tm->tm_sec);
//printf("(%s)\n", cmd);
  if (write(fd, cmd, strlen(cmd)) < 0)
	perror("sRTCW():");
  if ((n = Recv(fd, buf, sizeof(buf))) < 0)
	fprintf(stderr, "sRTCW(): Recv() error\n");
  if (dflg)
	dump(buf, n);
  sscanf(buf + 6, "%2X", &x);
//printf("*0x%02X*\n", x);
  if (x != 0x00) {
	if (x == 0x02)
		t = "եޥåȥ顼";
	else if (x == 0x03)
		t = "CRC 顼";
	else if (x == 0x04)
		t = "ǡĹ顼";
	else if (x == 0x07)
		t = "̤ޥ";
	fprintf(stderr, "S-RTCW: %s\n", t);
	return -1;
  }
  sscanf(buf + 26, "%2X", &x);
  if (x == 0x00)
	return 0;
  if (x == 0x05)
	t = "ϰϳ";
  else if (x == 0x07)
	t = "ꥨ顼";
  fprintf(stderr, "S-RTCW: %s\n", t);
  return -1;
}

// ơ

int sRS()
{
  char *cmd = "AA550AFF1000F0F0F0000000FF00\r\n";
  char *s, *t;
  int i, n, x;
  unsigned int u;

//printf("(%s)\n", cmd);
  if (write(fd, cmd, strlen(cmd)) < 0)
	perror("sRS():");
  if ((n = Recv(fd, buf, sizeof(buf))) < 0)
	fprintf(stderr, "sRS(): Recv() error\n");
  if (dflg)
	dump(buf, n);
  sscanf(buf + 28, "%4X", &x);
  printf("顼: %04X\n", x);
  sscanf(buf + 32, "%2X", &x);
  if (x == 0x00)
	t = "˥ư";
  else if (strcmp(t, "0x01") == 0)
	t = "Ͽư";
  else if (strcmp(t, "0x02") == 0)
	t = "ˤѹ";
  else if (strcmp(t, "0x03") == 0)
	t = "̿ˤѹ";
  else if (strcmp(t, "0x04") == 0)
	t = "FTP ư";
  else if (strcmp(t, "0x06") == 0)
	t = "˥åѹ";
  printf("ư: %s\n", t);
  sscanf(buf + 34, "%4X", &u);
  printf("Ͽǡ: %d\n", u);
  sscanf(buf + 38, "%2X", &x);
  if (x == 0x00)
	t = "SD ̤";
  else if (x == 0x01)
	t = "SD ";
  printf("SD : %s\n", t);
  sscanf(buf + 40, "%2X", &x);
  if (x == 0x00)
	t = "OFF";
  else if (x == 0x01)
	t = "ON";
  printf("顼Ͼ: %s\n", t);
  return 0;
}

// 顼

int cCLRERR()
{
  char *cmd = "AA550AFF6013F0F0F0000000FF00\r\n";
  char *s;
  int i, n, x;
  double t, h;

//printf("(%s)\n", cmd);
  if (write(fd, cmd, strlen(cmd)) < 0)
	perror("cLRERR():");
  if ((n = Recv(fd, buf, sizeof(buf))) < 0)
	fprintf(stderr, "cCLRERR(): Recv() error\n");
  if (dflg)
	dump(buf, n);
  return 0;
}

// 顼

int cCLRALM()
{
  char *cmd = "AA550AFF6012F0F0F0000000FF00\r\n";
  char *s;
  int i, n, x;
  double t, h;

//printf("(%s)\n", cmd);
  if (write(fd, cmd, strlen(cmd)) < 0)
	perror("cLRALM():");
  if ((n = Recv(fd, buf, sizeof(buf))) < 0)
	fprintf(stderr, "cCLRALM(): Recv() error\n");
  if (dflg)
	dump(buf, n);
  return 0;
}

// ɤ߽Ф

struct {
  int n; char *s;
} sRpar[] = {
  { 0x01, "ư⡼" },
  { 0x02, "¬⡼" },
  { 0x03, "Ͽ⡼" },
  { 0x04, "꡼׻ɽ" },
  { 0x05, "¬" },
  { 0x06, "顼ۡ" },
  { 0x07, ";(CH1)" },
  { 0x08, "Ͳ(CH1)" },
  { 0x09, ";(CH2)" },
  { 0x0A, "Ͳ(CH2)" },
  { 0x17, "(CH1)" },
  { 0x18, "(CH2)" },
  { 0x1F, "IP ɥ쥹" },
  { 0x20, "֥ͥåȥޥ" },
  { 0x21, "ǥեȥȥ" },
  { 0x22, "ݡֹ" },
  { -1, NULL }
};

// ɤ߽Ф

int sR()
{
  static char *ptab1[] = { "NET", "SLEEP", "PD-S" };
  static char *ptab2[] = { "NORM", "MAX", "MIN", "AVE" };
  static char *ptab3[] = { "CONT", "RING" };
  static char *ptab4[] = { "OFF", "ON" };
  static char *ptab5[] = {
	"1 ", "2 ", "5 ", "10 ", "20 ", "30 ", "1 ʬ", "2 ʬ",
	"5 ʬ", "10 ʬ", "20 ʬ", "30 ʬ", "1 "
	};
  char *fmt = "AA550CFF1010F0F0F0000000FF00%02X00\r\n";
  char *s, cmd[64];
  int i, j, k, n;
  uint32_t x;
  double t, h;

//printf("(%s)\n", cmd);
  for (i = 0; sRpar[i].s != NULL; i++) {
	sprintf(cmd, fmt, sRpar[i].n);
//printf("(%s)\n", cmd);
	if (write(fd, cmd, strlen(cmd)) < 0)
		perror("cLRALM():");
	if ((n = Recv(fd, buf, sizeof(buf))) < 0)
		fprintf(stderr, "cCLRALM(): Recv() error\n");
//printf("n(%d)(%s)\n", n, buf);
	if (dflg)
		dump(buf, n);
	sscanf(buf + 28, "%08X", &x);
//printf("%s: 0x%8.8s (0x%04X)\n", sRpar[i].s, buf + 28, x);
	printf("%s: ", sRpar[i].s);
	if (sRpar[i].n == 0x01)
		printf("%s\n", ptab1[x]);
	else if (sRpar[i].n == 0x02)
		printf("%s\n", ptab2[x]);
	else if (sRpar[i].n == 0x03)
		printf("%s\n", ptab3[x]);
	else if (sRpar[i].n == 0x04)
		printf("%s\n", ptab4[x]);
	else if (sRpar[i].n == 0x05)
		printf("%s\n", ptab5[x]);
	else if (sRpar[i].n == 0x06)
		printf("%s\n", x == 0 ? "OFF" : "ON");
	else if (0x07 <= sRpar[i].n && sRpar[i].n <= 0x18)
		printf("%d\n", x);
	else if (0x1F <= sRpar[i].n && sRpar[i].n <= 0x21) {
//printf("%s: 0x%8.8s (0x%04X)\n", sRpar[i].s, buf + 28, x);
		for (j = 0; j < 4; j++) {
			sscanf(buf + 28 + 6 - j * 2, "%2X", &k);
			printf("%d", k);
			if (j < 3)
				printf(".");
			else
				printf("\n");
		}
	}
	else if (sRpar[i].n == 0x22)
		printf("%d\n", x);
  }
  return 0;
}

// ͽ񤭹

int sW(par, val) int par, val;
{
  char *fmt = "AA5510FF1011F0F0F0000000FF00%02X%08X00\r\n";
  char cmd[64];
  char *s;
  int i, n;

printf("(%s)\n", cmd);
  par = 0x21;
  val = (1 << 24) | (3 << 16) | (168 << 8) | 192;
printf("0x%02X 0x%08X\n", par, val);
  sprintf(cmd, fmt, par, val);
printf("(%s)\n", cmd);
return 0;
  if (write(fd, cmd, strlen(cmd)) < 0)
	perror("sW():");
  if ((n = Recv(fd, buf, sizeof(buf))) < 0)
	fprintf(stderr, "sW(): Recv() error\n");
printf("n(%d)(%s)\n", n, buf);
  if (dflg)
	dump(buf, n);
  return 0;

}

// Ͽ

int cSTARTREC()
{
  char *cmd = "AA550AFF6000F0F0F0000000FF00\r\n";
  char *s;
  int i, n, x;
  double t, h;

//printf("(%s)\n", cmd);
  if (write(fd, cmd, strlen(cmd)) < 0)
	perror("cLRALM():");
  if ((n = Recv(fd, buf, sizeof(buf))) < 0)
	fprintf(stderr, "cCLRALM(): Recv() error\n");
  if (dflg)
	dump(buf, n);
  return 0;
}

// Ͽ

int cSTOPREC()
{
  char *cmd = "AA550AFF6001F0F0F0000000FF00\r\n";
  char *s;
  int i, n, x;
  double t, h;

//printf("(%s)\n", cmd);
  if (write(fd, cmd, strlen(cmd)) < 0)
	perror("cLRALM():");
  if ((n = Recv(fd, buf, sizeof(buf))) < 0)
	fprintf(stderr, "cCLRALM(): Recv() error\n");
  if (dflg)
	dump(buf, n);
  return 0;
}

// Ͽǡ񤭽Ф

int cOUTREC()
{
  char *cmd = "AA550AFF6002F0F0F0000000FF00\r\n";
  char *s;
  int i, n, x;
  double t, h;

//printf("(%s)\n", cmd);
  if (write(fd, cmd, strlen(cmd)) < 0)
	perror("cLRALM():");
  if ((n = Recv(fd, buf, sizeof(buf))) < 0)
	fprintf(stderr, "cCLRALM(): Recv() error\n");
  if (dflg)
	dump(buf, n);
  return 0;

}

// ꥻå(Ƶư)

int cRESET()
{
  char *cmd = "AA550AFF6010F0F0F0000000FF00\r\n";
  char *s;
  int i, n, x;
  double t, h;

//printf("(%s)\n", cmd);
  if (write(fd, cmd, strlen(cmd)) < 0)
	perror("cLRALM():");
  if ((n = Recv(fd, buf, sizeof(buf))) < 0)
	fprintf(stderr, "cCLRALM(): Recv() error\n");
  if (dflg)
	dump(buf, n);
  return 0;
}

int sMODE(val) int val;
{
  char *fmt = "AA550BFF1020F0F0F0000000FF%02X00\r\n";
  char cmd[64];
  char *s;
  int i, n, x;
  double t, h;

//printf("(%s)\n", cmd);
  sprintf(cmd, fmt, val);
printf("(%s)\n", cmd);
  if (write(fd, cmd, strlen(cmd)) < 0)
	perror("cLRALM():");
  if ((n = Recv(fd, buf, sizeof(buf))) < 0)
	fprintf(stderr, "cCLRALM(): Recv() error\n");
  if (dflg)
	dump(buf, n);
  return 0;

}

int setGateway(adr) char *adr;
{
  int hadr;
  char cmd[64];

  if (atoh(adr, &hadr) < 0)
	return -1;
  sMODE(0x01);	// ѹ⡼
  sW(0x21, hadr);
  sMODE(0x00);	// ¬⡼
  return 0;
}

int htoa(s, t, n) char *s, *t; int n;
{
  int i, x;

  for (i = 0; i < n; i++) {
	sscanf(s + i * 2, "%2X", &x);
	*(t + i) = x;
  }
  *(t + i) = '\0';
  return 0;
}

int atoh(s, x) char *s; int *x;
{
  int a, b, c, d, n;
  char hadr[64];

  n = sscanf(s, "%d.%d.%d.%d", &a, &b, &c, &d);
//printf("n(%d) %d %d %d %d\n", n, a, b, c, d);
  if (n != 4) {
	fprintf(stderr, "ޥɥ顼: IP ɥ쥹 192.168.0.1 Τ褦 10 ɽǻꤷޤ\n");
	return -1;
  }
  sprintf(hadr, "%02X%02X%02X%02X", d, c, b, a);
  *x = (d << 24) | (c << 16) | (b << 8) | a;
//printf(buf, "0x%08X\n", x);
  return 0;
}


/*
 * ޥɱ
 */

int Recv(fd, buf, siz) char *buf;
{
  char c, *s, *t;
  int i, k, n, x, y, z;

  alarm(4);
  n = 0;
  s = buf;
  while (n < siz) {
	if ((k = read(fd, s, siz)) <= 0) {
		if (vflg)
			perror("Recv(): read() error: ");
	        return -1;
	}
	*(s + k) = '\0';
	if (vflg)
		printf("Recv(): %d\n", k);
	for (i = 0; i < k; i++) {
		n++;
		c = *s & 0xff;
		if (*s++ == '\n') {
			*s = '\0';
			// check error
			sscanf(buf + 6, "%2X", &x);	// suntax check code
			sscanf(buf + 26, "%2X", &y); // response code
			sscanf(buf + 10, "%4X", &z); // command code
//printf("0x%02X 0x%02X 0x%04X\n", x, y, z);
			if (x != 0x00 || y != 0x00)
				printf("ޥɥ: 0x%04X\n", z);
			if (x != 0x00) {
				if (x == 0x02)
					t ="եޥåȥ顼";
				else if (x == 0x03)
					t = "CRC 顼";
				else if (x == 0x04)
					t = "ǡĹ顼";
				else if (x == 0x07)
					t ="̤ޥ";
				fprintf(stderr, "Recv(): %s\n", t);
			}
			if (y != 0x00) {
				if (y == 0x01)
					t ="ѥ᡼ʥСϰϳ";
				else if (y == 0x02)
					t = "ϰϳ";
				else if (y == 0x03)
					t = "ɤ߽Ф顼";
				else if (y == 0x04)
					t = "ͽ񤭹ߥ顼";
				else if (y == 0x05)
					t = "ϰϳ";
				else if (y == 0x06)
					t = "顼";
				else if (y == 0x07)
					t = "ꥨ顼";
				else if (y == 0x0A)
					t = "¹Խʤ⡼";
				else if (y == 0x0B)
					t = "顼";
				else if (y == 0x10)
					t = "󥵥顼";
				else if (y == 0x11)
					t = "ϡɥ顼";
				else if (y == 0x20)
					t = "SD ̤";
				else if (y == 0x21)
					t = "SD ɽ񤭹ߥ顼";
				else if (y == 0x22)
					t = "SD ɤ߹ߥ顼";
				else if (y == 0x23)
					t = "SD ɥԲ(Ű㲼)";
				else if (y == 0x24)
					t = "SD ɥ饤ȥץƥ";
				else if (y == 0x25)
					t = "SD ɥ";
				else if (y == 0x26)
					t = "SD ǧ顼";
				else if (y == 0x83)
					t = "Ͱ賰";
				fprintf(stderr, "Recv(): %s\n", t);
			}
			if (dflg)
				printf("n(%d)(%s)\n", n, buf);
			return n;
		}
	}
  }
  return -1;
}

/*
 * ǡʤɤ 16 ʥ
 */

int dump(s, n) char *s;
{
  int i;

  for (i = 0; i < n; i++) {
	if (0 < i)
		printf(" ");
	printf("%02X", s[i] & 0xFF);
  }
  printf("\n");
  return 0;
}

char *strsave(s) char *s;
{
  char *p;

  if ((p = (char *)malloc(strlen(s) + 1)) == NULL)
	error("memory over.", (char *)0);
  return strcpy(p, s);
}

void error(s, t) char *s, *t;
{
  fprintf(stderr, "%s: ", cmd);
  fprintf(stderr, s, t);
  fprintf(stderr, "\n");
  exit(1);
}

void Usage()
{
  static char *t[] = {
"ޥ	%s - OMRON ZN-THX21-S ",
"ʸ		%s [ץ] [ۥ]",
"ץ", 
" -B			# Ͽ", 
" -E			# Ͽ",
" -G gateway		# Default Gateway ",
" -O			# Ͽ񤭽Ф",
" -P ѥ᡼ 	# ѥ᡼񤭹",
" -R			# ꥻå(Ƶư)",
" -T			# ",
" -a			# 顼ꥻå",
" -e			# 顼ꥻå",
" -p			# ѥ᡼ɤ߽Ф",
" -s			# ơɤ߽Ф",
" -t			# ɤ߽Ф",
"",
" %s			# ǥե IP address Υ󥵤¬ɤ߽Ф",
" %s 192.168.3.41	# 192.168.3.41 Υ󥵤¬ɤ߽Ф",
" %s -T			# ǥե IP address ΥǥХ˸߻",
" %s -T 192.168.3.41	# 192.168.3.41 Υ󥵤˸߻",
" %s -t			# ǥե IP address Υ󥵤ɤ߽Ф",
" %s -t 192.168.3.41	# 192.168.3.41 Υ󥵤ɤ߽Ф",
" %s -s			# ǥե IP address Υ󥵤饹ơɤ߽Ф",
" %s -s	192.168.3.41	# 192.168.3.41 Υ󥵤饹ơɤ߽Ф",
" %s -p			# ǥե IP address Υ󥵤ѥ᡼ɤߤ",
" %s -p 192.168.3.41	# 192.168.3.41 Υ󥵤ѥ᡼ɤߤ",
" %s -P0x01,1		# ǥե IP address Υ󥵤򥹥꡼ץ⡼ɤ",
" %s -P0x01,1 192.168.3.41	# 192.168.3.4s1 Υ󥵤򥹥꡼ץ⡼ɤ",
" %s -G192.168.3.1	# Default Gateway  192.168.3.1 ",
" %s -G192.168.3.1 192.168.3.41	# 192.168.3.41 Default Gateway  192.168.3.1 ",
"OMRON ZN-THX21-S Ȳ٥ơȤ߹碌ΤߤоݤǤ",
"ZN-DPX21S(ơ)ZN-KMX21(̥ơ)",
"ZN-CTX21(ʰϥ)D6FZ-FGS21(ή̥ơ)",
"D6FZ-1000(ή̥)оݳǤɲäϴñǤ",
"ץꤷʤϡֲ() м(%%)פɽޤ",
"κǸ IP address ϥۥ̾ꤷϤΥ󥵡ꤷʤ",
"ϡѥ˷ޤǥե륤 IP address ۥ̾Υ󥵤оݤˤ",
"ޤ",
"-P ץΥѥ᡼(121)ǽͤ OMRON Ρ̿ޥɥޥ˥",
"פɤ README 򸫤Ƥ",
  NULL
  };
  int i;

  for (i = 0; t[i] != NULL; i++) {
	fprintf(stderr, t[i], cmd);
	fprintf(stderr, "\n");
  }
  exit(1);
}
